Last Comment Bug 772005 - Further improve notification of new chat messages
: Further improve notification of new chat messages
Status: RESOLVED FIXED
:
Product: Thunderbird
Classification: Client Software
Component: Instant Messaging (show other bugs)
: Trunk
: x86_64 All
: -- normal with 1 vote (vote)
: Thunderbird 17.0
Assigned To: Richard Marti (:Paenglab)
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-09 02:37 PDT by Andreas Nilsson (:andreasn)
Modified: 2012-10-26 05:24 PDT (History)
6 users (show)
ryanvm: in‑testsuite-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
fixed
fixed


Attachments
animation proposal (mac) (52.56 KB, image/gif)
2012-07-11 10:53 PDT, Andreas Nilsson (:andreasn)
no flags Details
message counter (29.90 KB, image/png)
2012-07-11 10:55 PDT, Andreas Nilsson (:andreasn)
no flags Details
WIP Patch 1 (7.16 KB, patch)
2012-07-20 12:57 PDT, Mike Conley (:mconley) - (Away until June 29th)
no flags Details | Diff | Review
WIP patch 2 (6.49 KB, patch)
2012-07-21 06:01 PDT, Richard Marti (:Paenglab)
no flags Details | Diff | Review
screenshot with long badge (2.74 KB, image/png)
2012-07-21 06:05 PDT, Richard Marti (:Paenglab)
no flags Details
Screenshot of text only toolbar (24.90 KB, image/png)
2012-07-23 08:47 PDT, Mike Conley (:mconley) - (Away until June 29th)
no flags Details
Patch (6.82 KB, patch)
2012-07-23 09:42 PDT, Richard Marti (:Paenglab)
mconley: review+
bwinton: ui‑review+
bwinton: approval‑comm‑aurora+
bwinton: approval‑comm‑beta+
Details | Diff | Review
Pixelated & oval badge (MacBook Air 13") (13.86 KB, image/png)
2012-07-31 06:56 PDT, Jb Piacentino
no flags Details

Description Andreas Nilsson (:andreasn) 2012-07-09 02:37:55 PDT
In bug #748358 we stopped opening a new tab and changed the icon when there were new unread chat messages.
JB suggested that we should try and do something more than just change the color (Win/Mac, Linux use a flare) to grab your attention. It would also be good to allow you to see the number of unread messages.
Comment 1 Andreas Nilsson (:andreasn) 2012-07-09 02:39:11 PDT
It's quite common to use a blinking icon in IM clients, so I would suggest to try that.
Comment 2 Andreas Nilsson (:andreasn) 2012-07-11 10:53:20 PDT
Created attachment 641114 [details]
animation proposal (mac)

Mockup of animation
Comment 3 Andreas Nilsson (:andreasn) 2012-07-11 10:55:03 PDT
Created attachment 641115 [details]
message counter

counter proposal (mac)
Comment 4 Mike Conley (:mconley) - (Away until June 29th) 2012-07-19 10:42:51 PDT
Blake - what are your thoughts on these?  My feeling is that the pulsing could get a bit irritating, and I'd go for the badge if possible...
Comment 5 Blake Winton (:bwinton) (:☕️) (PTO 'til London. Find me there for quick answers!) 2012-07-19 11:14:08 PDT
Yep, exactly that.
Comment 6 Mike Conley (:mconley) - (Away until June 29th) 2012-07-20 12:57:31 PDT
Created attachment 644429 [details] [diff] [review]
WIP Patch 1

First crack at this - I had to add a new XBL binding for a special toolbarbutton that has a "badge" element. I couldn't just toss a label inside a toolbarbutton, otherwise the icon / label would go away. :/

Positioning the badge is a little tricky, and I'm going to see if I can get Paenglab's help on this too.

Failing that, we can embed a badge into the unreadMessage icon, just without a count.
Comment 7 Mike Conley (:mconley) - (Away until June 29th) 2012-07-20 12:58:52 PDT
Paenglab:

Hey - would you have some time to help me out here too? I'm trying to position the red badge overtop of the Chat button icon, but it's rather tricky...hovering over the icon often causes the badge to move around, which is strange.

-Mike
Comment 8 Richard Marti (:Paenglab) 2012-07-21 06:01:01 PDT
Created attachment 644628 [details] [diff] [review]
WIP patch 2

What about this?

The badge is also shown in text only mode. Maybe it should be then different styled because the user don't want icons and the badge should look more like a text element.

What I saw during testing is when changing the button mode (text, icon only, text beside etc.) the badge value is deleted. This isn't important because it's unlikely someone plays a lot with the mode. But maybe it's a bug?
Comment 9 Richard Marti (:Paenglab) 2012-07-21 06:05:57 PDT
Created attachment 644629 [details]
screenshot with long badge

When are a lot of unread messages, everything after the badge is shifted to the right. I think it's okay like this because overlapping other elements shouldn't happen, especially in icon only mode it would then overlap the next button.
Comment 10 Mike Conley (:mconley) - (Away until June 29th) 2012-07-23 08:47:43 PDT
Created attachment 644946 [details]
Screenshot of text only toolbar

Richard:

This looks *awesome*, thank you so much. Just one issue - when in text-only mode for the toolbar, the badge hovers over top of the text, and causes a rather strange appearance. See my attachment.

With that fixed, I think it'll be ready for review.

-Mike
Comment 11 Richard Marti (:Paenglab) 2012-07-23 09:42:03 PDT
Created attachment 644962 [details] [diff] [review]
Patch

(In reply to Mike Conley (:mconley) from comment #10)
> This looks *awesome*, thank you so much. Just one issue - when in text-only
> mode for the toolbar, the badge hovers over top of the text, and causes a
> rather strange appearance. See my attachment.

You tried before the icon and text mode, didn't you? When you select then text only then the box-orient is vertical. I added a -moz-box-orient: horizontal; when in text mode to force the badge to be on the side.

> With that fixed, I think it'll be ready for review.

Okay, here it is.
Comment 12 Blake Winton (:bwinton) (:☕️) (PTO 'til London. Find me there for quick answers!) 2012-07-23 11:36:26 PDT
Comment on attachment 644962 [details] [diff] [review]
Patch

Nice!  ui-r=me!
Comment 13 Mike Conley (:mconley) - (Away until June 29th) 2012-07-24 08:19:42 PDT
Comment on attachment 644962 [details] [diff] [review]
Patch

Code looks good - let's roll with this.

Thanks so much Richard - this is fantastic work!
Comment 14 Ryan VanderMeulen [:RyanVM] 2012-07-24 18:24:47 PDT
https://hg.mozilla.org/comm-central/rev/3f7c3f228397
Comment 15 Blake Winton (:bwinton) (:☕️) (PTO 'til London. Find me there for quick answers!) 2012-07-25 11:59:15 PDT
Comment on attachment 644962 [details] [diff] [review]
Patch

This seems like something we want for the initial IM release.
Comment 16 Mike Conley (:mconley) - (Away until June 29th) 2012-07-27 10:31:44 PDT
comm-aurora: https://hg.mozilla.org/releases/comm-aurora/rev/6bbf30dd330f
comm-beta: https://hg.mozilla.org/releases/comm-beta/rev/105ee0a9ef2d
Comment 17 Jb Piacentino 2012-07-31 06:56:24 PDT
Created attachment 647517 [details]
Pixelated & oval badge (MacBook Air 13")
Comment 18 Jb Piacentino 2012-07-31 06:57:40 PDT
On my Macbook Air 13", the red badge looks a little bit pixelated and oval (i.s.o round). See attached picture.
Comment 19 Blake Winton (:bwinton) (:☕️) (PTO 'til London. Find me there for quick answers!) 2012-07-31 07:01:20 PDT
Comment on attachment 647517 [details]
Pixelated & oval badge (MacBook Air 13")

For reference, here's the notification on Things, a native Mac app: http://dl.dropbox.com/u/2301433/Screenshots/redOval.png
Seems pretty oval to me, so I think our shape is okay.  I'm not sure what to do to make it smoother.  Perhaps we just live with it, since the number inside isn't the important thing, but rather the existence (or not) of the red button is.
Comment 20 Jb Piacentino 2012-07-31 07:10:10 PDT
I have a hard time understanding the behavior and meaning of the different signals. I am under the assumption that
- a blue envelope means 'there are new chat messages'
- a red badge means 'your name, or a tracked keyword (Twitter) is contained in one of the new chat messages', or 'you have a direct message'.

The behavior I see does not correspond to this description. Please see  http://imgur.com/a/DMf8T for a screen shot of the toolbar notification and Chat panel report.
Comment 21 Jb Piacentino 2012-07-31 07:11:44 PDT
(In reply to Blake Winton (:bwinton - Thunderbird UX) from comment #19)
> Comment on attachment 647517 [details]
> Pixelated & oval badge (MacBook Air 13")
> 
> For reference, here's the notification on Things, a native Mac app:
> http://dl.dropbox.com/u/2301433/Screenshots/redOval.png
> Seems pretty oval to me, so I think our shape is okay. 
Your oval is larger than tall. Mine is the opposite. My personal taste goes to your layout, but this maybe just my own taste...
Comment 22 mathieu 2012-10-26 05:24:37 PDT
As this bug seems general enough, I'd like to propose to send desktop notification when the status is 'Available' and Thunderbird is not focused. This is quite usual with IM application to notify new message on arrival (sender & message) 
I think that with empathy/gnome3, the notification can be used to answer without going to the app - but that's overkill IMHO.

what do you think? should I open a seperated bug?

Note You need to log in before you can comment on or make changes to this bug.